Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 9305)
@@ -101,10 +101,13 @@
     }
 
-    public ExperimentEntity(string user, string experimentName, string experimentUrl) {
+    public ExperimentEntity(string user, string experimentName, string experimentId, string experimentUrl) {
       PartitionKey = "ScenarioPartition";
       RowKey = user + "_" + experimentName;      
       User = user;
+      ExperimentId = experimentId;
       ExperimentJsonUrl = experimentUrl;
     }
+
+    public string ExperimentId { get; set; }
 
     public string User { get; set; }
@@ -122,20 +125,38 @@
         return false;
 
-      // TODO: Save the whole experiment, not just the algorithm names!!!
       CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.EXPERIMENT_BLOB_CONTAINER);
       container.CreateIfNotExist();
       // For now we store it as JSON element in the blob store
-      // TODO: Make sure, that all required properties are part of the experiment!!
-      var experimentJson = AlgorithmConverter.ConvertJson(experiment);
+      var experimentJson = AlgorithmConverter.ConvertExperimentToJson(experiment);
       Guid experimentJsonGuid = Guid.NewGuid();
       var experimentJsonId = experiment.Name + "_" + experimentJsonGuid.ToString();
+      experimentJson["nodeId"] = experimentJsonId.ToString();
       var blob = container.GetBlobReference(experimentJsonId);      
-      blob.UploadText(experimentJson);
+      blob.UploadText(experimentJson.ToString());
+      experiment.Id = experimentJsonId;
 
       TableServiceContext serviceContext = TableClient.GetDataServiceContext();      
       TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
-      var entity = new ExperimentEntity(username, experiment.Name, blob.Uri.ToString());
+      var entity = new ExperimentEntity(username, experiment.Name, experiment.Id, blob.Uri.ToString());
       serviceContext.AddObject(AzureConstants.EXPERIMENT_TABLE, entity);
       serviceContext.SaveChangesWithRetries();
+      return true;
+    }
+
+    public bool Update(string username, Experiment experiment) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
+      var entity = (from e in serviceContext.CreateQuery<ExperimentEntity>(AzureConstants.EXPERIMENT_TABLE)
+                    where e.ExperimentId == experiment.Id
+                    select e).FirstOrDefault();
+      if (entity == null) {
+        return false;
+      }
+
+      CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.EXPERIMENT_BLOB_CONTAINER);
+      container.CreateIfNotExist();
+      var blob = container.GetBlobReference(entity.ExperimentJsonUrl);
+      var experimentJson = AlgorithmConverter.ConvertExperimentToJson(experiment).ToString();
+      blob.UploadText(experimentJson);
       return true;
     }
@@ -177,5 +198,5 @@
       container.CreateIfNotExist();
       var blob = container.GetBlobReference(entity.ExperimentJsonUrl);
-      return AlgorithmConverter.ConvertExperimentSimple(blob.DownloadText());
+      return AlgorithmConverter.ConvertJsonToExperiment(blob.DownloadText());
     }
 
@@ -199,5 +220,5 @@
       foreach (var entity in entites) {
         var blob = container.GetBlobReference(entity.ExperimentJsonUrl);
-        experiments.Add(AlgorithmConverter.ConvertExperimentSimple(blob.DownloadText()));
+        experiments.Add(AlgorithmConverter.ConvertJsonToExperiment(blob.DownloadText()));
       }
       return experiments;
@@ -218,7 +239,28 @@
       container.CreateIfNotExist();
       var blob = container.GetBlobReference(entity.ExperimentJsonUrl);
-      var exp = AlgorithmConverter.ConvertExperimentSimple(blob.DownloadText());
+      var exp = AlgorithmConverter.ConvertJsonToExperiment(blob.DownloadText());
       return exp;
     }
+
+
+    public Experiment GetExperimentById(User user, string nodeId) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
+      var entity = (from e in serviceContext.CreateQuery<ExperimentEntity>(AzureConstants.EXPERIMENT_TABLE)
+                    where e.ExperimentId == nodeId
+                    select e).FirstOrDefault();
+      if (entity == null || entity.ExperimentJsonUrl == null) {
+        return null;
+      }
+
+      if (entity.User != user.Username)
+        return null;
+
+      CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.EXPERIMENT_BLOB_CONTAINER);
+      container.CreateIfNotExist();
+      var blob = container.GetBlobReference(entity.ExperimentJsonUrl);
+      return AlgorithmConverter.ConvertJsonToExperiment(blob.DownloadText());
+    }
+
   }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs	(revision 9305)
@@ -97,6 +97,6 @@
         foreach (var child in entry.Children) {
           // This is a template experiment; 
-          if (child.Name == null) {
-            var parent = new HeuristicLab.Optimization.Experiment(child.Name);
+          if (child.IsExperiment) {
+            var parent = new HeuristicLab.Optimization.Experiment();
             entry.Parent.Optimizers.Add(parent);
             stack.Push(new StackEntry() { Parent = parent, Children = child.ChildAlgorithms });          
@@ -104,17 +104,10 @@
           // This entity is mapable
           else {           
-            IScenarioMapper mapper = GetMapper(child.Name);
-            if (mapper == null) { // TODO: We should really be able to difference Experiment/Algorithm types; this is a workaround
-              var parent = new HeuristicLab.Optimization.Experiment(child.Name);
-              entry.Parent.Optimizers.Add(parent);
-              stack.Push(new StackEntry() { Parent = parent, Children = child.ChildAlgorithms });          
-            }
-            else {
-              var optScen = new OptimizationScenario() { Id = child.Name };
-              optScen.Algorithm.Add(child);
-              IAlgorithm algo;
-              mapper.MapScenario(optScen, out algo);
-              entry.Parent.Optimizers.Add(algo);
-            }
+            IScenarioMapper mapper = GetMapper(child.Id);
+            var optScen = new OptimizationScenario() { Id = child.Id };
+            optScen.Algorithm.Add(child);
+            IAlgorithm algo;
+            mapper.MapScenario(optScen, out algo);
+            entry.Parent.Optimizers.Add(algo);
           }  
         }
@@ -166,5 +159,6 @@
     private IScenarioMapper GetMapper(string scenarioId) {
       var id = scenarioId;
-      if (!mappers.ContainsKey(id)) {
+      IScenarioMapper mapper = null;      
+      if (!mappers.TryGetValue(id, out mapper)) {
         lock (lockable) {
           if (mappers.ContainsKey(id))
@@ -173,5 +167,5 @@
           var mapperString = GetMapperFromBlobStore(id);
           if (mapperString == null) return null;
-          var mapper = CompileMapper(mapperString);
+          mapper = CompileMapper(mapperString);
 
           mappers[id] = mapper;
@@ -179,5 +173,5 @@
         } // lock        
        } // if
-      return null;
+      return mapper;
      }  
 
@@ -471,9 +465,15 @@
     }
 
-    public bool SaveExperiment(User user, Model.Experiment experiment) {
-      return dal.ExperimentDao.Add(user.Username, experiment);
-    }
-
-    public IEnumerable<string> GetExperiments(User user) {
+    public string SaveExperiment(User user, Model.Experiment experiment) {
+      if (experiment.Id != null) {
+        dal.ExperimentDao.Update(user.Username, experiment);
+      }
+      else {
+        dal.ExperimentDao.Add(user.Username, experiment);
+      }
+      return experiment.Id;
+    }
+
+    public IEnumerable<string> GetExperimentNames(User user) {
       return (from exp in dal.ExperimentDao.GetExperiments(user.Username)
               select exp.Name);
@@ -564,6 +564,11 @@
     }
 
-
-
+    public IEnumerable<Model.Experiment> GetExperiments(User user) {
+      return dal.ExperimentDao.GetExperiments(user.Username);
+    }
+
+    public Model.Experiment GetExperimentById(User user, string nodeId) {
+      return dal.ExperimentDao.GetExperimentById(user, nodeId);
+    }
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj	(revision 9305)
@@ -189,5 +189,7 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="packages.config" />
+    <None Include="packages.config">
+      <SubType>Designer</SubType>
+    </None>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 9305)
@@ -20,8 +20,11 @@
   public interface IExperimentDao {
     bool Add(string username, Experiment experiment);
+    bool Update(string username, Experiment experiment);
     bool DeleteByName(string username, string experiment);
     Experiment FindByName(string username, string experiment);
     IEnumerable<Experiment> GetExperiments(string user);
     Experiment GetExperimentByName(string username, string scenario);
+
+    Experiment GetExperimentById(User user, string nodeId);
   }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 9305)
@@ -44,8 +44,11 @@
 
     [OperationContract]
-    bool SaveExperiment(User user, Experiment experiment);
+    string SaveExperiment(User user, Experiment experiment);
 
     [OperationContract]
-    IEnumerable<string> GetExperiments(User user);
+    IEnumerable<string> GetExperimentNames(User user);
+
+    [OperationContract]
+    IEnumerable<Experiment> GetExperiments(User user);
 
     [OperationContract]
@@ -60,4 +63,7 @@
     [OperationContract]
     Experiment GetExperimentByName(User user, string scenario);
+
+    [OperationContract]
+    Experiment GetExperimentById(User u, string nodeId);
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 9305)
@@ -15,6 +15,10 @@
     bool DeleteScenario(User user, string scenarioName);
 
-    bool SaveExperiment(User user, Experiment experiment);
-    IEnumerable<string> GetExperiments(User user);
+    string SaveExperiment(User user, Experiment experiment);
+    IEnumerable<string> GetExperimentNames(User user);
+    IEnumerable<Model.Experiment> GetExperiments(User user);
+    Experiment GetExperimentByName(User user, string scenario);
+    Experiment GetExperimentById(User user, string nodeId);
+
     bool DeleteExperiment(User user, string experiment);
 
@@ -22,5 +26,5 @@
     Job GetTasks(User u, string jobId);
 
-    Experiment GetExperimentByName(User user, string scenario);
+    
     bool DispatchExperiment(User user, Experiment exp, JobExecutionDetails details);
   }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs	(revision 9305)
@@ -277,4 +277,7 @@
 
     [DataMember]
+    public string Id { get; set; }
+
+    [DataMember]
     public AlgorithmParameters Parameters { get; set; }
 
@@ -293,4 +296,7 @@
     [DataMember]
     public string Name { get; set; }
+
+    [DataMember]
+    public bool IsExperiment { get; set; }
   }
 
@@ -315,4 +321,7 @@
     [DataMember]
     public IList<Algorithm> Algorithm { get; set; }
+
+    [DataMember]
+    public string Id { get; set; }
 
     public Experiment() {
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs	(revision 9305)
@@ -241,10 +241,10 @@
 
 
-    public bool SaveExperiment(User user, Model.Experiment experiment) {
-      throw new NotImplementedException();
-    }
-
-
-    public IEnumerable<string> GetExperiments(User user) {
+    public string SaveExperiment(User user, Model.Experiment experiment) {
+      throw new NotImplementedException();
+    }
+
+
+    public IEnumerable<string> GetExperimentNames(User user) {
       throw new NotImplementedException();
     }
@@ -271,4 +271,17 @@
 
     public bool DispatchExperiment(User user, Model.Experiment exp, JobExecutionDetails details) {
+      throw new NotImplementedException();
+    }
+
+
+    string IScenarioManager.SaveExperiment(User user, Model.Experiment experiment) {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<Model.Experiment> GetExperiments(User user) {
+      throw new NotImplementedException();
+    }
+
+    public Model.Experiment GetExperimentById(User user, string nodeId) {
       throw new NotImplementedException();
     }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs	(revision 9305)
@@ -9,76 +9,23 @@
 namespace HeuristicLab.Services.Optimization.ControllerService.Parsers {
   public static class AlgorithmConverter {
-
-    public static Algorithm Convert(string json) {
-      var o = JObject.Parse(json);
-      return ParseAlgorithm(o);      
-    }
-
-    private static Algorithm ParseAlgorithm(JToken obj) {
-      var algorithm = new Algorithm();
-
-      foreach (JProperty param in obj["Algorithm Parameters"]) {
-        Parameter parameter = CreateParameter(param);
-        algorithm.Parameters.Items.Add(parameter);
-      }
-
-      var problemParams = obj["Problem Parameters"];
-      if (problemParams != null) {
-        algorithm.Problem = new Problem();
-        foreach (JProperty param in problemParams) {
-          Parameter parameter = CreateParameter(param);
-          algorithm.Problem.Parameters.Items.Add(parameter);
-        }
-      }
-      return algorithm;
-    }
-
-    public static Algorithm ConvertAppend(string json, Algorithm algorithm) {
-      var o = JObject.Parse(json);
-      foreach (JProperty param in o["Algorithm Parameters"]) {
-        Parameter parameter = CreateParameter(param);
-        var oldParameter = (from p in algorithm.Parameters.Items where p.Value.Name == parameter.Value.Name select p).FirstOrDefault();
-        if (oldParameter != null) {
-          oldParameter.Value = parameter.Value;
-        }
-        else {
-          algorithm.Parameters.Items.Add(parameter);
-        }
-      }
-
-      var problemParams = o["Problem Parameters"];
-      if (problemParams != null) {
-        algorithm.Problem = new Problem();
-        foreach (JProperty param in problemParams) {
-          Parameter parameter = CreateParameter(param);          
-          var oldParameter = (from p in algorithm.Problem.Parameters.Items where p.Value.Name == parameter.Value.Name select p).FirstOrDefault();
-          if (oldParameter != null) {
-            oldParameter.Value = parameter.Value;
-          }
-          else {
-            algorithm.Problem.Parameters.Items.Add(parameter);
-          }
-        }
-      }
-      return algorithm;
-    }
-
-    private static Parameter CreateParameter(JProperty property) {
-      JToken token = property.Value;
-      switch (token.Type) {
+    #region private methods
+    private static Parameter CreateParameter(JObject property) {
+      var name = (string)property["Name"];
+      var value = property["Value"];
+      switch (value.Type) {
         case JTokenType.Integer:
         case JTokenType.Float:
-          return new Parameter() { Type = ParameterType.Decimal, Value = new DecimalValue() { Name = property.Name, Value = (double)property.Value } };
+          return new Parameter() { Type = ParameterType.Decimal, Value = new DecimalValue() { Name = name, Value = (double)value } };
         case JTokenType.Boolean:
-          return new Parameter() { Type = ParameterType.Boolean, Value = new BoolValue() { Name = property.Name, Value = (bool)property.Value } };
+          return new Parameter() { Type = ParameterType.Boolean, Value = new BoolValue() { Name = name, Value = (bool)value } };
         case JTokenType.String:
-          return new Parameter() { Type = ParameterType.Type, Value = new TypeValue() { Name = property.Name, Value = (string)property.Value } };                  
+          return new Parameter() { Type = ParameterType.Type, Value = new TypeValue() { Name = name, Value = (string)value, Options = (from e in property["Options"] select (string)e).ToArray() } };
         case JTokenType.Array:
-          var arr = (JArray)token;
+          var arr = (JArray)value;
           // its a matrix
           if (arr[0].Type == JTokenType.Array) {
-            return CreateMatrixParameter(property.Name, arr);
+            return CreateMatrixParameter(name, arr);
           }
-          return CreateVectorParameter(property.Name, arr);
+          return CreateVectorParameter(name, arr);
         default:
           throw new Exception("Unhandled datatype: " + property.Type);
@@ -89,5 +36,5 @@
       double[][] entries = new double[arr.Count][];
       for (int i = 0; i < entries.Length; i++) {
-        entries[i] = (from d in arr[i] select (double)d).ToArray<double>();  
+        entries[i] = (from d in arr[i] select (double)d).ToArray<double>();
       }
       return new Parameter { Type = ParameterType.DecimalMatrix, Value = new DecimalMatrix() { Name = name, Value = entries } };
@@ -99,9 +46,4 @@
     }
 
-    public static string ConvertJson(Algorithm algorithm) {
-      return JsonConvert.SerializeObject(algorithm);
-    }
-
-    
     private class StackEntry {
       public Algorithm Parent { get; set; }
@@ -109,39 +51,174 @@
     }
 
-    public static Experiment ConvertExperimentSimple(string json) {
-      return JsonConvert.DeserializeObject<Experiment>(json, new JsonSerializerSettings() { TypeNameHandling = TypeNameHandling.Auto });
-    }
-
-    public static string ConvertJson(Experiment experiment) {
-      return JsonConvert.SerializeObject(experiment, Formatting.None, new JsonSerializerSettings { TypeNameHandling = TypeNameHandling.Auto });
-    }
-
-    public static Experiment ConvertExperiment(string json) {
+    private static JArray ConvertParametersToJson(IList<Parameter> parameters) {
+      var array = new JArray();
+      foreach (var param in parameters) {
+        array.Add(JObject.FromObject(param.Value));
+      }
+      return array;
+    }
+
+    private struct Entry {
+      public JObject TargetAlgorithm { get; set; }
+
+      public Algorithm SourceAlgorithm { get; set; }
+    }
+
+    private static Algorithm ParseAlgorithm(JToken jsonAlgorithm) {
+      var algorithm = new Algorithm();
+
+      foreach (JObject param in jsonAlgorithm["AlgorithmParameters"]) {
+        Parameter parameter = CreateParameter(param);
+        algorithm.Parameters.Items.Add(parameter);
+      }
+
+      var problemParams = jsonAlgorithm["ProblemParameters"];
+      if (problemParams != null) {
+        algorithm.Problem = new Problem();
+        foreach (JObject param in problemParams) {
+          Parameter parameter = CreateParameter(param);
+          algorithm.Problem.Parameters.Items.Add(parameter);
+        }
+      }
+      return algorithm;
+    }
+    #endregion
+
+
+    #region public methods
+
+
+    public static JObject ConvertExperimentToJson(Experiment experiment) {
+      var exp = new JObject();
+      exp["title"] = experiment.Name;
+      exp["children"] = new JArray();
+      exp["nodeId"] = experiment.Id;
+      exp["isExperiment"] = true;
+
+      var stack = new Stack<Entry>();
+      foreach (var algo in experiment.Algorithm)
+        stack.Push(new Entry() { TargetAlgorithm = exp, SourceAlgorithm = algo });
+
+      while (stack.Count > 0) {
+        var entry = stack.Pop();
+        var algorithm = ConvertAlgorithmToJson(entry.SourceAlgorithm);
+        (entry.TargetAlgorithm["children"] as JArray).Add(algorithm);
+
+        if (entry.SourceAlgorithm.ChildAlgorithms.Count > 0) {
+          // push children
+          foreach (var child in entry.SourceAlgorithm.ChildAlgorithms) {
+            stack.Push(new Entry() { TargetAlgorithm = algorithm, SourceAlgorithm = child });
+          }
+        }
+
+      }
+      return exp;
+    }
+
+    public static JArray ConvertExperimentsToJson(IEnumerable<Experiment> experiments) {
+      var jarray = new JArray();
+      foreach (var exp in experiments)
+        jarray.Add(ConvertExperimentToJson(exp));
+      return jarray;
+    }
+
+    public static JArray ConvertAlgorithmsToJson(IEnumerable<Algorithm> algorithms) {
+      var jarray = new JArray();
+      foreach (var algo in algorithms)
+        jarray.Add(ConvertAlgorithmToJson(algo));
+      return jarray;
+    }
+
+
+    public static JArray ConvertScenariosToJson(IEnumerable<OptimizationScenario> scenarios) {
+      var jarray = new JArray();
+      foreach (var scen in scenarios)
+        jarray.Add(ConvertScenarioToJson(scen));
+      return jarray;
+    }
+
+    public static JObject ConvertScenarioToJson(OptimizationScenario scenario) {
+      var exp = new JObject();
+      exp["title"] = scenario.Id;
+      exp["children"] = new JArray();
+      exp["nodeId"] = scenario.Id;
+      exp["isExperiment"] = false;
+
+      var stack = new Stack<Entry>();
+      var baseAlgorithm = ConvertAlgorithmToJson(scenario.FirstAlgorithm);
+      exp["data"] = baseAlgorithm["data"];
+      if (scenario.FirstAlgorithm.ChildAlgorithms.Count > 0) {
+        foreach (var child in scenario.FirstAlgorithm.ChildAlgorithms)
+          stack.Push(new Entry() { TargetAlgorithm = exp, SourceAlgorithm = child});
+      }
+
+      while (stack.Count > 0) {
+        var entry = stack.Pop();
+        var algorithm = ConvertAlgorithmToJson(entry.SourceAlgorithm);
+        (entry.TargetAlgorithm["children"] as JArray).Add(algorithm);
+
+        if (entry.SourceAlgorithm.ChildAlgorithms.Count > 0) {
+          // push children
+          foreach (var child in entry.SourceAlgorithm.ChildAlgorithms) {
+            stack.Push(new Entry() { TargetAlgorithm = algorithm, SourceAlgorithm = child });
+          }
+        }
+
+      }
+      return exp;
+    }
+
+    public static JObject ConvertAlgorithmToJson(Algorithm algorithm) {
+      var jalgo = new JObject();
+      jalgo["title"] = algorithm.Name;
+      jalgo["nodeId"] = algorithm.Id;
+      var jalgoData = new JObject();
+      jalgo["data"] = jalgoData;
+      jalgo["isExperiment"] = algorithm.IsExperiment;
+      jalgoData["AlgorithmParameters"] = ConvertParametersToJson(algorithm.Parameters.Items);
+      if (algorithm.Problem != null && algorithm.Problem.Parameters != null)
+        jalgoData["ProblemParameters"] = ConvertParametersToJson(algorithm.Problem.Parameters.Items);
+
+      jalgo["children"] = new JArray();
+      return jalgo;
+    }
+
+    public static Experiment ConvertJsonToExperiment(string json) {
       var experiment = new Experiment();
       var jsonExperiment = JObject.Parse(json);
-      experiment.Name = (string)jsonExperiment["name"];
+      experiment.Name = (string)jsonExperiment["title"];
+      experiment.Id = (string)jsonExperiment["nodeId"];      
       var stack = new Stack<StackEntry>();
       var root = new Algorithm();
 
-      if ((bool)jsonExperiment["run"]) {
+      if (jsonExperiment["run"] != null && (bool)jsonExperiment["run"]) {
         experiment.JobDetails = new JobExecutionDetails() {
-           Group = (string)jsonExperiment["group"],
-           Repititions = (int)jsonExperiment["repititions"]
+          Group = (string)jsonExperiment["group"],
+          Repititions = (int)jsonExperiment["repititions"]
         };
       }
 
-      foreach (var algo in jsonExperiment["algorithms"]["children"]) {
-        stack.Push(new StackEntry(){ Parent = root, Child = algo });
-      }
+      // ignore experiment node, skip to its children
+      if (jsonExperiment["experiment"] != null)
+        foreach (var algo in jsonExperiment["experiment"]["children"]) {
+          stack.Push(new StackEntry() { Parent = root, Child = algo });
+        }
+
+      if (jsonExperiment["children"] != null)
+        foreach (var algo in jsonExperiment["children"]) {
+          stack.Push(new StackEntry() { Parent = root, Child = algo });
+        }
 
       while (stack.Count > 0) {
         var entry = stack.Pop();
         var data = entry.Child["data"];
-        var currentAlgo = data == null ? new Algorithm() : ParseAlgorithm(entry.Child["data"]);
-        currentAlgo.Name = (string)entry.Child["name"];
+        var currentAlgo = data == null || !data.HasValues ? new Algorithm() : ParseAlgorithm(entry.Child["data"]);
+        currentAlgo.Name = (string)entry.Child["title"];
+        currentAlgo.Id = (string)entry.Child["nodeId"];
+        currentAlgo.IsExperiment = (bool)entry.Child["isExperiment"];
         entry.Parent.ChildAlgorithms.Add(currentAlgo);
         // push children on stack (inverse order to preserve ordering)
         var cnt = entry.Child["children"].Count();
-        for (var i=0; i < cnt; i++) {
+        for (var i = 0; i < cnt; i++) {
           stack.Push(new StackEntry() { Parent = currentAlgo, Child = entry.Child["children"][cnt - 1 - i] });
         }
@@ -154,4 +231,5 @@
       return experiment;
     }
+    #endregion
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 9305)
@@ -121,5 +121,5 @@
 
 
-    public bool SaveExperiment(User user, Experiment experiment) {      
+    public string SaveExperiment(User user, Experiment experiment) {      
       // make sure all algorithms store their choices aswell
       var scenarioMap = new Dictionary<string, OptimizationScenario>();
@@ -146,15 +146,15 @@
 
       // finally store the experiment
-      var success = hiveManager.SaveExperiment(user, experiment);
+      var id = hiveManager.SaveExperiment(user, experiment);
       // if it has been stored, and jobdetails are present, run the job!
-      if (success && experiment.JobDetails != null) {
-        return ScheduleExperiment(user, experiment.Name, experiment.JobDetails);
+      if (id != null && experiment.JobDetails != null) {
+        ScheduleExperiment(user, experiment.Id, experiment.JobDetails);
       }
-      return success;
+      return id;
     }
 
 
-    public IEnumerable<string> GetExperiments(User user) {
-      return hiveManager.GetExperiments(user);
+    public IEnumerable<string> GetExperimentNames(User user) {
+      return hiveManager.GetExperimentNames(user);
     }
 
@@ -179,7 +179,16 @@
 
 
-    public bool ScheduleExperiment(User user, string experiment, JobExecutionDetails details) {
-      var exp = hiveManager.GetExperimentByName(user, experiment);
+    public bool ScheduleExperiment(User user, string experimentId, JobExecutionDetails details) {
+      var exp = hiveManager.GetExperimentById(user, experimentId);
       return hiveManager.DispatchExperiment(user, exp, details);
+    }
+
+
+    public IEnumerable<Experiment> GetExperiments(User user) {
+      return hiveManager.GetExperiments(user);
+    }
+
+    public Experiment GetExperimentById(User u, string nodeId) {
+      return hiveManager.GetExperimentById(u, nodeId);
     }
   }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Binders/AlgorithmJsonAttribute.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Binders/AlgorithmJsonAttribute.cs	(revision 9304)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Binders/AlgorithmJsonAttribute.cs	(revision 9305)
@@ -13,38 +13,4 @@
 namespace Mvc3TestApplication.Binders
 {
-  public class AlgorithmJsonAttribute : CustomModelBinderAttribute
-  {
-    public override IModelBinder GetBinder()
-    {
-      return new AlgorithmJsonBinder();
-    }
-  }
-
-  public class AlgorithmJsonBinder : IModelBinder
-  {
-    public AlgorithmJsonBinder()
-    {
-    }
-
-    public object BindModel(ControllerContext controllerCtx, ModelBindingContext bindingCtx)
-    {
-      var contentType = controllerCtx.HttpContext.Request.ContentType;
-      if (!contentType.StartsWith("application/json", StringComparison.OrdinalIgnoreCase))
-        return null;
-
-      string body;
-      using (var stream = controllerCtx.HttpContext.Request.InputStream)
-      {
-        stream.Seek(0, System.IO.SeekOrigin.Begin);
-        using (var reader = new StreamReader(stream))
-          body = reader.ReadToEnd();
-      }
-      if (string.IsNullOrEmpty(body)) return null;
-      return AlgorithmConverter.Convert(body);
-    }
-
-    
-  }
-
   public class ExperimentJsonAttribute : CustomModelBinderAttribute {
     public override IModelBinder GetBinder() {
@@ -69,5 +35,5 @@
       }
       if (string.IsNullOrEmpty(body)) return null;
-      return AlgorithmConverter.ConvertExperiment(body);
+      return AlgorithmConverter.ConvertJsonToExperiment(body);
     }
 
